using UnityEditor;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UIElements;


public class WorldSpaceDialogueBox : MonoBehaviour {

    //Only the different parts for now

    private UIDocument uiDocument;
    [SerializeField] protected VisualTreeAsset visualTree;
    [SerializeField] protected StyleSheet styleSheet;
    [SerializeField] Katas.Experimental.WorldSpaceUIDocument worldSpaceUIDocument;
    private VisualElement root;
    private Button[] buttons;


    public void Awake() {
        worldSpaceUIDocument.onUIDocumentReady.AddListener(setUIDocument);
    }

    private void setUIDocument() {
        uiDocument = GetComponent<UIDocument>();
        root = uiDocument.rootVisualElement;
        VisualElement tree = visualTree.CloneTree();
        tree.styleSheets.Add(styleSheet);
        root.Add(tree);
        buttons = root.Query<Button>().ToList().ToArray();

        for (var i = 0; i < buttons.Length; i++) {
            var index = i;
            buttons[i].RegisterCallback<MouseUpEvent>(_ => GetComponent<ArticyStoryline>().ApplyTransition(index));
        }

    }

}



